package com.adc.da.test.controller;

import java.io.Serializable;
import java.util.Arrays;
import java.util.List;
import javax.validation.constraints.NotNull;
import com.adc.da.mp.base.IBaseService;
import com.adc.da.mp.base.Query;
import com.adc.da.util.http.PageInfo;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.test.entity.BClxxEO;
import com.adc.da.test.service.IBClxxEOService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import org.springframework.web.bind.annotation.RequestMapping;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;
import com.adc.da.mp.base.BaseController;

/**
 * <p>
 *  前端控制器
 * </p>
 * 作者 gen
 * 日期 2021-10-25
 */
@RestController
@RequestMapping("/${restPath}/test/bClxx")
@Api(tags = "|BClxxEO|")
public class BClxxEOController extends BaseController<BClxxEO> {
    private static final Logger logger = LoggerFactory.getLogger(BClxxEOController.class);

    @Autowired
    private IBClxxEOService service;

    @ApiOperation(value = "|BClxxEO|列表查询", notes = "test:bclxx:list")
    @PostMapping(value = "list", consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:bclxx:list")
    public ResponseMessage<List<BClxxEO>> getList(@RequestBody Query<BClxxEO> query) {

        return Result.success(super.list(query));
    }

    @ApiOperation(value = "|BClxxEO|分页查询", notes = "test:bclxx:page")
    @PostMapping(value = "page", consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:bclxx:page")
    public ResponseMessage<PageInfo<BClxxEO>> getPage(@RequestBody Query<BClxxEO> query) {

        return Result.success(getPageInfo(super.page(query)));
    }

    @ApiOperation(value = "|BClxxEO|详情", notes = "test:bclxx:get")
    @GetMapping("{id}")
    //@RequiresPermissions("test:bclxx:get")
    public ResponseMessage<BClxxEO> get(@NotNull @PathVariable Serializable id) {

        return Result.success(super.getById(id));
    }

    @ApiOperation(value = "|BClxxEO|新增", notes = "test:bclxx:save")
    @PostMapping(consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:bclxx:save")
    public ResponseMessage<BClxxEO> create(@RequestBody BClxxEO data) {

        return Result.success(super.save(data));
    }

    @ApiOperation(value = "|BClxxEO|修改", notes = "test:bclxx:update")
    @PutMapping(consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:bclxx:update")
    public ResponseMessage<BClxxEO> modify(@RequestBody BClxxEO data) {

        return Result.success(super.update(data));
    }

    @ApiOperation(value = "|BClxxEO|批量删除", notes = "test:bclxx:delete")
    @DeleteMapping("{ids}")
    //@RequiresPermissions("test:bclxx:delete")
    public ResponseMessage delete(@NotNull @PathVariable Serializable... ids) {

         return Result.success(super.deleteBatchIds(ids));
    }

    @Override
    protected IBaseService<BClxxEO> getService() {

        return service;
    }

    @Override
    protected void verifyQuery(Query<BClxxEO> queryItem) {

    }

    @Override
    protected void verifySaveData(BClxxEO data) {

    }

    @Override
    protected void verifyUpdateData(BClxxEO data) {

    }

    @Override
    protected void verifyDeleteId(Serializable... ids) {

    }
}
