package com.adc.da.test.controller;

import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.io.Serializable;
import java.util.List;

import javax.validation.constraints.NotNull;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.adc.da.mp.base.BaseController;
import com.adc.da.mp.base.IBaseService;
import com.adc.da.mp.base.Query;
import com.adc.da.test.entity.PdfInfoEO;
import com.adc.da.test.service.IPdfInfoEOService;
import com.adc.da.util.http.PageInfo;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;

/**
 * <p>
 *  前端控制器
 * </p>
 * 作者 gen
 * 日期 2021-08-20
 */
@RestController
@RequestMapping("/${restPath}/test/pdfInfo")
@Api(tags = "|PdfInfoEO|")
public class PdfInfoEOController extends BaseController<PdfInfoEO> {
    private static final Logger logger = LoggerFactory.getLogger(PdfInfoEOController.class);

    @Autowired
    private IPdfInfoEOService service;

    @ApiOperation(value = "|PdfInfoEO|列表查询", notes = "test:pdfinfo:list")
    @PostMapping(value = "list", consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:pdfinfo:list")
    public ResponseMessage<List<PdfInfoEO>> getList(@RequestBody Query<PdfInfoEO> query) {

        return Result.success(super.list(query));
    }

    @ApiOperation(value = "|PdfInfoEO|分页查询", notes = "test:pdfinfo:page")
    @PostMapping(value = "page", consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:pdfinfo:page")
    public ResponseMessage<PageInfo<PdfInfoEO>> getPage(@RequestBody Query<PdfInfoEO> query) {

        return Result.success(getPageInfo(super.page(query)));
    }

    @ApiOperation(value = "|PdfInfoEO|详情", notes = "test:pdfinfo:get")
    @GetMapping("{id}")
    //@RequiresPermissions("test:pdfinfo:get")
    public ResponseMessage<PdfInfoEO> get(@NotNull @PathVariable Serializable id) {

        return Result.success(super.getById(id));
    }

    @ApiOperation(value = "|PdfInfoEO|新增", notes = "test:pdfinfo:save")
    @PostMapping(consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:pdfinfo:save")
    public ResponseMessage<PdfInfoEO> create(@RequestBody PdfInfoEO data) {

        return Result.success(super.save(data));
    }

    @ApiOperation(value = "|PdfInfoEO|修改", notes = "test:pdfinfo:update")
    @PutMapping(consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:pdfinfo:update")
    public ResponseMessage<PdfInfoEO> modify(@RequestBody PdfInfoEO data) {

        return Result.success(super.update(data));
    }

    @ApiOperation(value = "|PdfInfoEO|批量删除", notes = "test:pdfinfo:delete")
    @DeleteMapping("{ids}")
    //@RequiresPermissions("test:pdfinfo:delete")
    public ResponseMessage delete(@NotNull @PathVariable Serializable... ids) {

         return Result.success(super.deleteBatchIds(ids));
    }

    @Override
    protected IBaseService<PdfInfoEO> getService() {

        return service;
    }

    @Override
    protected void verifyQuery(Query<PdfInfoEO> queryItem) {

    }

    @Override
    protected void verifySaveData(PdfInfoEO data) {

    }

    @Override
    protected void verifyUpdateData(PdfInfoEO data) {

    }

    @Override
    protected void verifyDeleteId(Serializable... ids) {

    }
}
