package com.adc.da.test.controller;

import java.io.Serializable;
import java.util.Arrays;
import java.util.List;
import javax.validation.constraints.NotNull;
import com.adc.da.mp.base.IBaseService;
import com.adc.da.mp.base.Query;
import com.adc.da.util.http.PageInfo;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.test.entity.QaAnswersEO;
import com.adc.da.test.service.IQaAnswersEOService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import org.springframework.web.bind.annotation.RequestMapping;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;
import com.adc.da.mp.base.BaseController;

/**
 * <p>
 *  前端控制器
 * </p>
 * 作者 gen
 * 日期 2021-09-06
 */
@RestController
@RequestMapping("/${restPath}/test/qaAnswers")
@Api(tags = "|QaAnswersEO|")
public class QaAnswersEOController extends BaseController<QaAnswersEO> {
    private static final Logger logger = LoggerFactory.getLogger(QaAnswersEOController.class);

    @Autowired
    private IQaAnswersEOService service;

    @ApiOperation(value = "|QaAnswersEO|列表查询", notes = "test:qaanswers:list")
    @PostMapping(value = "list", consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:qaanswers:list")
    public ResponseMessage<List<QaAnswersEO>> getList(@RequestBody Query<QaAnswersEO> query) {

        return Result.success(super.list(query));
    }

    @ApiOperation(value = "|QaAnswersEO|分页查询", notes = "test:qaanswers:page")
    @PostMapping(value = "page", consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:qaanswers:page")
    public ResponseMessage<PageInfo<QaAnswersEO>> getPage(@RequestBody Query<QaAnswersEO> query) {

        return Result.success(getPageInfo(super.page(query)));
    }

    @ApiOperation(value = "|QaAnswersEO|详情", notes = "test:qaanswers:get")
    @GetMapping("{id}")
    //@RequiresPermissions("test:qaanswers:get")
    public ResponseMessage<QaAnswersEO> get(@NotNull @PathVariable Serializable id) {

        return Result.success(super.getById(id));
    }

    @ApiOperation(value = "|QaAnswersEO|新增", notes = "test:qaanswers:save")
    @PostMapping(consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:qaanswers:save")
    public ResponseMessage<QaAnswersEO> create(@RequestBody QaAnswersEO data) {

        return Result.success(super.save(data));
    }

    @ApiOperation(value = "|QaAnswersEO|修改", notes = "test:qaanswers:update")
    @PutMapping(consumes = APPLICATION_JSON_VALUE)
    //@RequiresPermissions("test:qaanswers:update")
    public ResponseMessage<QaAnswersEO> modify(@RequestBody QaAnswersEO data) {

        return Result.success(super.update(data));
    }

    @ApiOperation(value = "|QaAnswersEO|批量删除", notes = "test:qaanswers:delete")
    @DeleteMapping("{ids}")
    //@RequiresPermissions("test:qaanswers:delete")
    public ResponseMessage delete(@NotNull @PathVariable Serializable... ids) {

         return Result.success(super.deleteBatchIds(ids));
    }

    @Override
    protected IBaseService<QaAnswersEO> getService() {

        return service;
    }

    @Override
    protected void verifyQuery(Query<QaAnswersEO> queryItem) {

    }

    @Override
    protected void verifySaveData(QaAnswersEO data) {

    }

    @Override
    protected void verifyUpdateData(QaAnswersEO data) {

    }

    @Override
    protected void verifyDeleteId(Serializable... ids) {

    }
}
